﻿Global c.f = 0.5 / Sqr(3)
Global r2.f = Sqr(3) / 2
Global r3.f = Sqr(3) / 6
Global ex = 300
Global sx = 100
Global sy = 100
Global x.f = 1
Global y.f = 0

Procedure po()
  Box(x * ex + sx, sy - y * ex,1,1,$FFFFFF)
  u.f = 0.5 * x - r2 * y
  v.f = -r2 * x - 0.5 * y
  Box(u * ex + sx, sy - v * ex,1,1,$FFFFFF)
  u.f = -0.5 * x + r2 * y + 1
  v.f = -r2 * x - 0.5 * y
  Box (u * ex + sx, sy - v * ex,1,1,$FFFFFF)
EndProcedure

If OpenWindow(0, 0, 0, 640, 480, "Koch", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 640, 480)
  
  RandomSeed(1234)
  StartDrawing(CanvasOutput(0))
  po()
  Box (0,0,640,480,0)
  StopDrawing()
  Repeat
    StartDrawing(CanvasOutput(0))
    If Random(7)&1
      x0.f = 0.5 * x + r3 * y
      y0.f = r3 * x - 0.5 * y
    Else
      x0 = 0.5 * x - r3 * y + 0.5
      y0 = -r3 * x - 0.5 * y + r3
    EndIf
    x = x0
    y = y0
    po()
    StopDrawing()
    Event = WindowEvent()
  Until Event = #PB_Event_CloseWindow
  
EndIf

; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 29
; FirstLine = 11
; Folding = -
; EnableXP